#!/bin/bash
# Submission script for Lemaitre3
#SBATCH --job-name=Si_structure
#SBATCH --time=00:10:00
#
#SBATCH --tasks-per-node=8
#SBATCH --cpus-per-task=1
#SBATCH --nodes=1

#SBATCH --mem-per-cpu=3600
#
#SBATCH --mail-user=nicolas.roisin@uclouvain.be
#SBATCH --mail-type=ALL



tasks_per_node=8
nthreads=1 # cpus-per-task
nodes=1
ncpu=`echo $nodes $tasks_per_node | awk '{print $1*$2}'`



module purge
module load releases/2021a
module load ABINIT

export OMP_NUM_THREADS=$nthreads

mpirun -np $ncpu abinit run.abi > log