#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Nov 19 11:07:58 2019

@author: nico
"""

import numpy as np

def straintensor(straintype,N=41,emin=-0.04,emax=0.04,C11=16.577,C12=6.393,C44=7.962)   : 
    # Constants
    retour=np.zeros((3,3,N))
    
    eps=np.linspace(emin,emax,N)
    
    # Initiation
    uniepsilon001=np.zeros((3,3,N))
    uniepsilon110=np.zeros((3,3,N))
    uniepsilon111=np.zeros((3,3,N))
    biepsilon001=np.zeros((3,3,N))
    biepsilon110=np.zeros((3,3,N))
    biepsilon111=np.zeros((3,3,N))
    shear001=np.zeros((3,3,N))
    shear110=np.zeros((3,3,N))
    shear111=np.zeros((3,3,N))
    
    # Matrix computation
    # Uniaxial
    uniepar001=-C12/(C11+C12)*eps
    uniepsilon001[0][0]=uniepar001
    uniepsilon001[0][1]=np.zeros(N)
    uniepsilon001[0][2]=np.zeros(N)
    uniepsilon001[1][0]=np.zeros(N)
    uniepsilon001[1][1]=uniepar001
    uniepsilon001[1][2]=np.zeros(N)
    uniepsilon001[2][0]=np.zeros(N)
    uniepsilon001[2][1]=np.zeros(N)
    uniepsilon001[2][2]=eps
    
    uniepar110=- ( 4*C12*C44 ) / ( 2*C11*C44+(C11+2*C12)*(C11-C12) )*eps 
    uniepsilon110[0][0]=0.5*(eps+uniepar110)
    uniepsilon110[0][1]=0.5*(eps-uniepar110)
    uniepsilon110[0][2]=np.zeros(N)
    uniepsilon110[1][0]=0.5*(eps-uniepar110)
    uniepsilon110[1][1]=0.5*(eps+uniepar110)
    uniepsilon110[1][2]=np.zeros(N)
    uniepsilon110[2][0]=np.zeros(N)
    uniepsilon110[2][1]=np.zeros(N)
    uniepsilon110[2][2]=uniepar110
    
    uniepar111 = - (C11 + 2*C12 - 2*C44) / (C11 + 2*C12 + 2*C44)*eps
    uniepsilon111[0][0] = (eps + 2*uniepar111) / 3
    uniepsilon111[0][1] = (eps - uniepar111) / 3
    uniepsilon111[0][2] = (eps - uniepar111) / 3
    uniepsilon111[1][0] = (eps - uniepar111) / 3
    uniepsilon111[1][1] = (eps + 2*uniepar111) / 3
    uniepsilon111[1][2] = (eps - uniepar111) / 3
    uniepsilon111[2][0] = (eps - uniepar111) / 3
    uniepsilon111[2][1] = (eps - uniepar111) / 3
    uniepsilon111[2][2] = (eps + 2*uniepar111) / 3
    
    # Biaxial
    bieper001 = -2 * C12 / C11 * eps
    biepsilon001[0][0] = eps
    biepsilon001[0][1] = np.zeros(N)
    biepsilon001[0][2] = np.zeros(N)
    biepsilon001[1][0] = np.zeros(N)
    biepsilon001[1][1] = eps
    biepsilon001[1][2] = np.zeros(N)
    biepsilon001[2][0] = np.zeros(N)
    biepsilon001[2][1] = np.zeros(N)
    biepsilon001[2][2] = bieper001
    
    bieper110 = -(C11+3*C12-2*C44)/(C11+C12+2*C44)*eps
    biepsilon110[0][0] = 0.5*(bieper110+eps)
    biepsilon110[0][1] = 0.5*(bieper110-eps)
    biepsilon110[0][2] = np.zeros(N)
    biepsilon110[1][0] = np.zeros(N)
    biepsilon110[1][1] = 0.5*(bieper110+eps)
    biepsilon110[1][2] = 0.5*(bieper110-eps)
    biepsilon110[2][0] = np.zeros(N)
    biepsilon110[2][1] = np.zeros(N)
    biepsilon110[2][2] = eps
    
    bieper111 = -2*(C11+2*C12-2*C44)/(C11+2*C12+4*C44)* eps
    biepsilon111[0][0] = (bieper111+2*eps)/3 
    biepsilon111[0][1] = (bieper111-eps)/3 
    biepsilon111[0][2] = (bieper111-eps)/3 
    biepsilon111[1][0] = (bieper111-eps)/3 
    biepsilon111[1][1] = (bieper111+2*eps)/3 
    biepsilon111[1][2] = (bieper111-eps)/3 
    biepsilon111[2][0] = (bieper111-eps)/3 
    biepsilon111[2][1] = (bieper111-eps)/3 
    biepsilon111[2][2] = (bieper111+2*eps)/3

    # Shear

    shear001[0][2] = eps
    shear001[2][0] = eps

    shear110[0][2] = eps/np.sqrt(2)
    shear110[2][0] = eps/np.sqrt(2)
    shear110[1][2] = eps/np.sqrt(2)
    shear110[2][2] = eps/np.sqrt(2)

    shear111[0][1] = eps/np.sqrt(3)
    shear111[0][2] = eps/np.sqrt(3)
    shear111[1][0] = eps/np.sqrt(3)
    shear111[1][2] = eps/np.sqrt(3)
    shear111[2][0] = eps/np.sqrt(3)
    shear111[2][1] = eps/np.sqrt(3)

    if straintype == "uni001":
        retour=uniepsilon001
    elif straintype == "uni110":
        retour=uniepsilon110         
    elif straintype == "uni111":
        retour=uniepsilon111      
    elif straintype == "bi001":
        retour=biepsilon001
    elif straintype == "bi110":
        retour=biepsilon110         
    elif straintype == "bi111":
        retour=biepsilon111
    if straintype == "shear001":
        retour=shear001
    elif straintype == "shear110":
        retour=shear110         
    elif straintype == "shear111":
        retour=shear111

      
            
    return retour

# rprim=np.array([[0.0, 5.083880873222, 5.083880873222],
# [5.083880873222, 0.0, 5.083880873222],
# [5.083880873222, 5.083880873222, 0.0]])
a=1

rprim=a*np.array([[1,0,0],[0,1,0],[0,0,1]])

xred=np.array([[0, 0, 0],
               [0, 0.5, 0.5],
               [0.5, 0, 0.5],
               [0.5, 0.5, 0],
               [0.25, 0.25, 0.25],
               [0.25, 0.75, 0.75],
               [0.75, 0.25, 0.75],
               [0.75, 0.75, 0.25]])

eps=np.linspace(0.5,2,4)
epsilon=straintensor("uni110", N=4,emin=0.5e-2,emax=2e-2)
dic={}
for i in range(4):

    print("_____________________________________\n uniaxial [along 110] "+str(eps[i])+" %")
    print("- Strain tensor :")
    print(epsilon[:,:,i])
    print("- Rprim :")
    print(rprim.dot(np.eye(3)+epsilon[:,:,i]))
    dic[eps[i]]=rprim.dot(np.eye(3)+epsilon[:,:,i])
    


